/**
 * @author Magne Haveraaen
 * @since 2014-09-03
 */
// implementation: implementation Sophus.RingfieldCxxDemo.boundedArrayRawCxxIndexedBinaryContextMap, file: "BasicCxxRaw/CxxBoundedArrayRawIndexedBinaryContextMap.hxx" 
#ifndef _INCLUDE_BASICCXXRAW_CXXBOUNDEDARRAYRAWINDEXEDBINARYCONTEXTMAP_HXX
#define _INCLUDE_BASICCXXRAW_CXXBOUNDEDARRAYRAWINDEXEDBINARYCONTEXTMAP_HXX
#include "CxxBoundedArrayRaw.hxx"
namespace BasicCxxRaw {
template<typename E, typename E2, typename bar_A2, typename bar_Context>
struct CxxBoundedArrayRawIndexedBinaryContextMap {
	typedef typename BasicCxxRaw::CxxBoundedArrayRaw<E>::CxxBoundedArrayRaw_impl::bar_A bar_A;
	typedef typename BasicCxxRaw::CxxBoundedArrayRaw<E>::CxxBoundedArrayRaw_impl::Intex Intex;

	template<typename BARA2_GETELEMENT_OP, typename BARA2_GETSIZE_OP, typename F_OP>
	struct CxxBoundedArrayRawIndexedBinaryContextMap_impl {

		/** require function barA2_getElement(:bar_A2, :Intex) : E2 */
		const BARA2_GETELEMENT_OP& barA2_getElement;

		/** require function barA2_getSize(:bar_A2) : Intex */
		const BARA2_GETSIZE_OP& barA2_getSize;

		/** require function f(:E, :E2, :bar_Context, :Intex) : E */
		const F_OP& f;
		
		CxxBoundedArrayRawIndexedBinaryContextMap_impl(const BARA2_GETELEMENT_OP& _barA2_getElement, const BARA2_GETSIZE_OP& _barA2_getSize, const F_OP& _f)
		: barA2_getElement(_barA2_getElement), barA2_getSize(_barA2_getSize), f(_f)
		{};
		
		/** procedure bar_mapf(upd :bar_A, obs :bar_A2, obs :bar_Context, obs :Intex, obs :Intex) */
		void bar_mapf(bar_A& a, const bar_A2& a2, const bar_Context& c, const Intex& low, const Intex& high) const {
			for (Intex i = low ; i < high; ++i) {
				a.data[i] = f(a.data[i],barA2_getElement(a2,i),c,i);
			}
		}
	};
	
	
};


}


#endif
