/**
 * @author Magne Haveraaen
 * @since 2014-04-25
 */
// implementation: implementation BasicCxxRaw.BoundedArrayCxxRaw.boundedArrayRawCxxPrefix, file: "BasicCxxRaw/CxxBoundedArrayRawPrefix.hxx" 
#ifndef _INCLUDE_BASICCXXRAW_CXXBOUNDEDARRAYRAWPREFIX_HXX
#define _INCLUDE_BASICCXXRAW_CXXBOUNDEDARRAYRAWPREFIX_HXX
#include "CxxBoundedArrayRaw.hxx"
namespace BasicCxxRaw {
template<typename E>
struct CxxBoundedArrayRawPrefix {
	typedef typename BasicCxxRaw::CxxBoundedArrayRaw<E>::CxxBoundedArrayRaw_impl::bar_A bar_A;
	typedef typename BasicCxxRaw::CxxBoundedArrayRaw<E>::CxxBoundedArrayRaw_impl::Intex Intex;

	template<typename STAR_OP>
	struct CxxBoundedArrayRawPrefix_impl {
		/** require function star(:E, :E) : E */
		const STAR_OP& star;
		
		CxxBoundedArrayRawPrefix_impl(const STAR_OP& _star)
			: star(_star)
			{};
		
		
		/** procedure bar_scan(upd :bar_A, obs :Intex, obs :Intex) */
		void bar_scan(bar_A& a, const Intex& low, const Intex& high) const {
			Intex newLow = (Intex)(low + (Intex)1);
			if(newLow<low) return;
			for (Intex i = newLow ; i < high; ++i) {
				a.data[i] = star(a.data[i-1],a.data[i]);
			}
		}
	};
	
	
};


}


#endif
