/**
 * @author Magne Haveraaen
 * @since 2013
 */
// implementation: implementation BasicCxxRaw.RepetitionCountCxxRaw.repeatIndexedRaw, file: "BasicCxxRaw/CxxRepetitionRepeatIndexedRaw.hxx" 
#ifndef _INCLUDE_BASICCXXRAW_CXXREPETITIONREPEATINDEXEDRAW_HXX
#define _INCLUDE_BASICCXXRAW_CXXREPETITIONREPEATINDEXEDRAW_HXX
namespace BasicCxxRaw {
template<typename Context, typename Counter, typename Data, typename Integer, typename Predicate, typename PreemptCounter>
struct CxxRepetitionRepeatIndexedRaw {
	template<typename PREDICATEFALSE_OP, typename PREDICATETRUE_OP, typename P_OP, typename SUCCESSOR_OP, typename SUCCESSORC_OP, typename SUCCESSORPC_OP, typename ZEROC_OP, typename ZEROPC_OP>
	struct CxxRepetitionRepeatIndexedRaw_impl {
		/** require function PredicateFALSE() : Predicate */
		const PREDICATEFALSE_OP& PredicateFALSE;
		
		/** require function PredicateTRUE() : Predicate */
		const PREDICATETRUE_OP& PredicateTRUE;
		
		/** require procedure p(upd :Data, obs :Context, out :Predicate, obs :Integer) */
		const P_OP& p;
		
		/** require procedure successor(upd :Integer) */
		const SUCCESSOR_OP& successor;
		
		/** require procedure successorC(upd :Counter) */
		const SUCCESSORC_OP& successorC;
		
		/** require procedure successorPC(upd :PreemptCounter) */
		const SUCCESSORPC_OP& successorPC;
		
		/** require function zeroC() : Counter */
		const ZEROC_OP& zeroC;
		
		/** require function zeroPC() : PreemptCounter */
		const ZEROPC_OP& zeroPC;
		
		CxxRepetitionRepeatIndexedRaw_impl(const PREDICATEFALSE_OP& _PredicateFALSE, const PREDICATETRUE_OP& _PredicateTRUE, const P_OP& _p, const SUCCESSOR_OP& _successor, const SUCCESSORC_OP& _successorC, const SUCCESSORPC_OP& _successorPC, const ZEROC_OP& _zeroC, const ZEROPC_OP& _zeroPC)
			: PredicateFALSE(_PredicateFALSE), PredicateTRUE(_PredicateTRUE), p(_p), successor(_successor), successorC(_successorC), successorPC(_successorPC), zeroC(_zeroC), zeroPC(_zeroPC)
			{};
		
		
		/** procedure repeatRaw(upd :Data, obs :Context, out :Predicate, upd :PreemptCounter, obs :Integer, obs :Counter) */
		void repeatRaw(Data& d, const Context& c, Predicate& preempt, PreemptCounter& pc, const Integer& s, const Counter& n) const {
            PreemptCounter pcOLD = pc;
            pc = zeroPC();
            preempt = PredicateFALSE();
            Integer ss = s;
            // Counter nn is always within range, should never be a problem with exceptions
            for (Counter nn = zeroC(); true; successorC(nn)) {
                    if(nn == n) break;
                    // std::cerr << " d=" << (long long int)d << " c=" << c << " preempt=" << (int)preempt << " pc=" << (int)pc << " ss=" << (int)ss << " nn=" << (int)nn << " n=" << (int)n << std::endl;
                    try {
                            p( d, c, preempt, ss );
                            successor(ss);
                    } catch (void* v) {
                            preempt = PredicateTRUE();
                    }
                    // std::cerr << " d=" << (long long int)d << " c=" << c << " preempt=" << (int)preempt << " pc=" << (int)pc << " ss=" << (int)ss << " nn=" << (int)nn << " n=" << (int)n << std::endl;
                    if( preempt == PredicateTRUE() ) {
                            if( pc == pcOLD ) {
                                    break;
                            }
                            // Never counted beyond pc, thus no problem with exceptions
                            successorPC(pc);
                    }
                    preempt = PredicateFALSE();
            }
            return;
		}
	};
	
	
};


}


#endif
