/**
 * @author Magne Haveraaen
 * @since 2015-04-08
 */
// implementation: implementation BasicCxxRaw.StringCxxRaw.stringLatinCxxRaw, file: "BasicCxxRaw/CxxStringUtf8HashRaw.hxx" 
#ifndef _INCLUDE_BASICCXXRAW_CXXSTRINGUTF8HASHRAW_HXX
#define _INCLUDE_BASICCXXRAW_CXXSTRINGUTF8HASHRAW_HXX
#include "BasicCxxRaw/CxxStringUtf8Raw.hxx"
#include "BasicCxxRaw/CxxSize_tRaw.hxx"
namespace BasicCxxRaw {
struct CxxStringUtf8HashRaw {
	struct CxxStringUtf8HashRaw_impl {

		/** Using the String definition from BasicCxxRaw/CxxStringUtf8Raw.hxx */
		typedef typename BasicCxxRaw::CxxStringUtf8Raw::CxxStringUtf8Raw_impl::String String;
		/** Using the Intex definition from BasicCxxRaw/CxxSize_tRaw.hxx */
		// typedef typename BasicCxxRaw::CxxSize_tRaw::CxxSize_tRaw_impl::Intex Intex;
		// error: 'Intex' in 'struct BasicCxxRaw::CxxSize_tRaw::CxxSize_tRaw_impl' does not name a type
		typedef size_t Intex;

		/** Using the C++11 standard library string hashing function.
		 * @see http://www.cplusplus.com/reference/functional/hash/
		 */
		static const std::hash<std::string> str_hash;

		/** function hashCode(:String) : Intex */
		Intex hashCode(const String& s) const {
			return str_hash(s.utf8string);
		}

		/** predicate stringHashCxxRaw_hashCode_repeatable_validation() */
		bool stringHashCxxRaw_hashCode_repeatable_validation() const {
			std::string str(u8"abcæøåعلعdef");
			Intex oldvalue = (Intex) 9875021424487530096ull;
			Intex newvalue = str_hash(str);
			bool error = newvalue != oldvalue;
			if (newvalue != oldvalue) {
				std::cerr << "BasicCxxRaw.BasicCxxRaw.hxx error: Hash value for reference string has changed, was "
						  << oldvalue << " is " << newvalue << " for '\"" << str << "\"'" << std::endl;
			}
			str = std::string(u8"0987654321");
			oldvalue = (Intex) 15584719967016385439ull;
			newvalue = str_hash(str);
			error |= newvalue != oldvalue;
			if (newvalue != oldvalue) {
				std::cerr << "BasicCxxRaw.BasicCxxRaw.hxx error: Hash value for reference string has changed, was "
						  << oldvalue << " is " << newvalue << " for '\"" << str << "\"'" << std::endl;
			}
			str = std::string(u8"");
			oldvalue = (Intex) 6142509188972423790ull;
			newvalue = str_hash(str);
			error |= newvalue != oldvalue;
			if (newvalue != oldvalue) {
				std::cerr << "BasicCxxRaw.BasicCxxRaw.hxx error: Hash value for reference string has changed, was "
						  << oldvalue << " is " << newvalue << " for '\"" << str << "\"'" << std::endl;
			}
			return !error;
		}

	};
	
	
};


const std::hash<std::string> CxxStringUtf8HashRaw::CxxStringUtf8HashRaw_impl::str_hash = {};
}


#endif
