/**
 * @author Magne Haveraaen
 * @since 2015-04-07
 */
// implementation: implementation BasicCxxRaw.StringCxxRaw.stringLatinCxxRaw, file: "BasicCxxRaw/CxxStringUtf8LatinRaw.hxx"
#ifndef _INCLUDE_BASICCXXRAW_CXXSTRINGUTF8LATINRAW_HXX
#define _INCLUDE_BASICCXXRAW_CXXSTRINGUTF8LATINRAW_HXX
#include "BasicCxxRaw/CxxStringUtf8Raw.hxx"
namespace BasicCxxRaw {
struct CxxStringUtf8LatinRaw {
	struct CxxStringUtf8LatinRaw_impl {
		
		/** Using the String definition from BasicCxxRaw/CxxStringUtf8Raw.hxx */
		typedef typename BasicCxxRaw::CxxStringUtf8Raw::CxxStringUtf8Raw_impl::String String;

		/** Whitespace characters. */
		String s_space() const { return String(u8" ");}
		String s_tab() const { return String(u8"\t");}
		String s_newline() const { return String(u8"\n");}

		/*** Single character strings, mostly Latin-1. */
		String s_A() const { return String(u8"A"); }
		String s_B() const { return String(u8"B"); }
		String s_C() const { return String(u8"C"); }
		String s_D() const { return String(u8"D"); }
		String s_E() const { return String(u8"E"); }
		String s_F() const { return String(u8"F"); }
		String s_G() const { return String(u8"G"); }
		String s_H() const { return String(u8"H"); }
		String s_I() const { return String(u8"I"); }
		String s_J() const { return String(u8"J"); }
		String s_K() const { return String(u8"K"); }
		String s_L() const { return String(u8"L"); }
		String s_M() const { return String(u8"M"); }
		String s_N() const { return String(u8"N"); }
		String s_O() const { return String(u8"O"); }
		String s_P() const { return String(u8"P"); }
		String s_Q() const { return String(u8"Q"); }
		String s_R() const { return String(u8"R"); }
		String s_S() const { return String(u8"S"); }
		String s_T() const { return String(u8"T"); }
		String s_U() const { return String(u8"U"); }
		String s_V() const { return String(u8"V"); }
		String s_W() const { return String(u8"W"); }
		String s_X() const { return String(u8"X"); }
		String s_Y() const { return String(u8"Y"); }
		String s_Z() const { return String(u8"Z"); }
		String s_AE() const { return String(u8"Æ"); }
		String s_OE() const { return String(u8"Œ"); }
		String s_Oslash() const { return String(u8"Ø"); }
		String s_Aring() const { return String(u8"Å"); }
		String s_Atrema() const { return String(u8"Ä"); }
		String s_Etrema() const { return String(u8"Ë"); }
		String s_Itrema() const { return String(u8"Ï"); }
		String s_Otrema() const { return String(u8"Ö"); }
		String s_Utrema() const { return String(u8"Ü"); }
		String s_Ytrema() const { return String(u8"Ÿ"); }
		String s_Aacute() const { return String(u8"Á"); }
		String s_Eacute() const { return String(u8"É"); }
		String s_Iacute() const { return String(u8"Í"); }
		String s_Oacute() const { return String(u8"Ó"); }
		String s_Uacute() const { return String(u8"Ú"); }
		String s_Yacute() const { return String(u8"Ý"); }
		String s_Agrave() const { return String(u8"À"); }
		String s_Egrave() const { return String(u8"È"); }
		String s_Igrave() const { return String(u8"Ì"); }
		String s_Ograve() const { return String(u8"Ò"); }
		String s_Ugrave() const { return String(u8"Ù"); }
		String s_Ygrave() const { return String(u8"Ỳ"); }
		String s_Acircumflex() const { return String(u8"Â"); }
		String s_Ecircumflex() const { return String(u8"Ê"); }
		String s_Icircumflex() const { return String(u8"Î"); }
		String s_Ocircumflex() const { return String(u8"Ô"); }
		String s_Ucircumflex() const { return String(u8"Û"); }
		String s_Ycircumflex() const { return String(u8"Ŷ"); }
		String s_Atilde() const { return String(u8"Ã"); }
		String s_Etilde() const { return String(u8"Ẽ"); }
		String s_Itilde() const { return String(u8"Ĩ"); }
		String s_Otilde() const { return String(u8"Õ"); }
		String s_Utilde() const { return String(u8"Ũ"); }
		String s_Ytilde() const { return String(u8"Ỹ"); }
		String s_Ccedilla() const { return String(u8"Ç"); }
		String s_Scaron() const { return String(u8"Šš"); }
		String s_Zcaron() const { return String(u8"Žž"); }
		String s_Eth() const { return String(u8"Ð"); }
		String s_Ntilde() const { return String(u8"Ñ"); }
		String s_Thorn() const { return String(u8"Þ"); }

		String s_a() const { return String(u8"a"); }
		String s_b() const { return String(u8"b"); }
		String s_c() const { return String(u8"c"); }
		String s_d() const { return String(u8"d"); }
		String s_e() const { return String(u8"e"); }
		String s_f() const { return String(u8"f"); }
		String s_g() const { return String(u8"g"); }
		String s_h() const { return String(u8"h"); }
		String s_i() const { return String(u8"i"); }
		String s_j() const { return String(u8"j"); }
		String s_k() const { return String(u8"k"); }
		String s_l() const { return String(u8"l"); }
		String s_m() const { return String(u8"m"); }
		String s_n() const { return String(u8"n"); }
		String s_o() const { return String(u8"o"); }
		String s_p() const { return String(u8"p"); }
		String s_q() const { return String(u8"q"); }
		String s_r() const { return String(u8"r"); }
		String s_s() const { return String(u8"s"); }
		String s_t() const { return String(u8"t"); }
		String s_u() const { return String(u8"u"); }
		String s_v() const { return String(u8"v"); }
		String s_w() const { return String(u8"w"); }
		String s_x() const { return String(u8"x"); }
		String s_y() const { return String(u8"y"); }
		String s_z() const { return String(u8"z"); }
		String s_ae() const { return String(u8"æ"); }
		String s_oe() const { return String(u8"œ"); }
		String s_oslash() const { return String(u8"ø"); }
		String s_aring() const { return String(u8"å"); }
		String s_atrema() const { return String(u8"ä"); }
		String s_etrema() const { return String(u8"ë"); }
		String s_itrema() const { return String(u8"ï"); }
		String s_otrema() const { return String(u8"ö"); }
		String s_utrema() const { return String(u8"ü"); }
		String s_ytrema() const { return String(u8"ÿ"); }
		String s_aacute() const { return String(u8"á"); }
		String s_eacute() const { return String(u8"é"); }
		String s_iacute() const { return String(u8"í"); }
		String s_oacute() const { return String(u8"ó"); }
		String s_uacute() const { return String(u8"ú"); }
		String s_yacute() const { return String(u8"ý"); }
		String s_agrave() const { return String(u8"à"); }
		String s_egrave() const { return String(u8"è"); }
		String s_igrave() const { return String(u8"ì"); }
		String s_ograve() const { return String(u8"ò"); }
		String s_ugrave() const { return String(u8"ù"); }
		String s_ygrave() const { return String(u8"ỳ"); }
		String s_acircumflex() const { return String(u8"â"); }
		String s_ecircumflex() const { return String(u8"ê"); }
		String s_icircumflex() const { return String(u8"î"); }
		String s_ocircumflex() const { return String(u8"ô"); }
		String s_ucircumflex() const { return String(u8"û"); }
		String s_ycircumflex() const { return String(u8"ŷ"); }
		String s_atilde() const { return String(u8"ã"); }
		String s_etilde() const { return String(u8"ẽ"); }
		String s_itilde() const { return String(u8"ĩ"); }
		String s_otilde() const { return String(u8"õ"); }
		String s_utilde() const { return String(u8"ũ"); }
		String s_ytilde() const { return String(u8"ỹ"); }
		String s_ccedilla() const { return String(u8"ç"); }
		String s_scaron() const { return String(u8"š"); }
		String s_zcaron() const { return String(u8"ž"); }
		String s_eth() const { return String(u8"ð"); }
		String s_ntilde() const { return String(u8"ñ"); }
		String s_thorn() const { return String(u8"þ"); }
		String s_sSharp() const { return String(u8"ß"); }

		/*** Punctuation symbols. */
		String s_atSign() const { return String(u8"@"); }
		String s_ampersand() const { return String(u8"&"); }
		String s_apostrophe() const { return String(u8"'"); }
		String s_colon() const { return String(u8":"); }
		String s_comma() const { return String(u8","); }
		String s_exclamationMark() const { return String(u8"!"); }
		String s_fullStop() const { return String(u8"."); }
		String s_interpunct() const { return String(u8"·"); }
		String s_invertedExclamationMark() const { return String(u8"¡"); }
		String s_invertedQuestionMark() const { return String(u8"¿"); }
		String s_pilcrow() const { return String(u8"¶"); }
		String s_questionMark() const { return String(u8"?"); }
		String s_quotationMark() const { return String(u8"\""); }
		String s_semicolon() const { return String(u8";"); }
		String s_sectionSign() const { return String(u8"§"); }
		String s_underscore() const { return String(u8"_"); }

		/*** Diacritical marks. */
		String s_acuteAccent() const { return String(u8"´"); }
		String s_cedilla() const { return String(u8"¸"); }
		String s_circumflex() const { return String(u8"^"); }
		String s_diaeresis() const { return String(u8"¨"); }
		String s_graveAccent() const { return String(u8"`"); }
		String s_macron() const { return String(u8"¯"); }
		String s_tilde() const { return String(u8"~"); }

		/*** Currency symbols. */
		String s_centSymbol() const { return String(u8"¢"); }
		String s_currency() const { return String(u8"¤"); }
		String s_dollarSign() const { return String(u8"$"); }
		String s_euro() const { return String(u8"€"); }
		String s_poundSign() const { return String(u8"£"); }
		String s_yenSign() const { return String(u8"¥"); }

		/*** Intellectual property symbols. */
		String s_copyright() const { return String(u8"©"); }
		String s_registeredTrademark() const { return String(u8"®"); }

		/*** Paranthesis. */
		String s_left_curlybraces() const { return String(u8"{"); }
		String s_right_curlybraces() const { return String(u8"}"); }
		String s_left_guillemet() const { return String(u8"«"); }
		String s_right_guillemet() const { return String(u8"»"); }
		String s_left_parenthesis() const { return String(u8"("); }
		String s_right_parenthesis() const { return String(u8")"); }
		String s_left_squarebrackets() const { return String(u8"["); }
		String s_right_squarebrackets() const { return String(u8"]"); }

		/*** Numbers. */
		String s_0() const { return String(u8"0"); }
		String s_1() const { return String(u8"1"); }
		String s_2() const { return String(u8"2"); }
		String s_3() const { return String(u8"3"); }
		String s_4() const { return String(u8"4"); }
		String s_5() const { return String(u8"5"); }
		String s_6() const { return String(u8"6"); }
		String s_7() const { return String(u8"7"); }
		String s_8() const { return String(u8"8"); }
		String s_9() const { return String(u8"9"); }
		String s_cube() const { return String(u8"³"); }
		String s_half() const { return String(u8"½"); }
		String s_quarter() const { return String(u8"¼"); }
		String s_square() const { return String(u8"²"); }
		String s_superscript1() const { return String(u8"¹"); }
		String s_threeQuarters() const { return String(u8"¾"); }

		/*** Numeric symbols. */
		String s_asterisk() const { return String(u8"*"); }
		String s_backslash() const { return String(u8"\\"); }
		String s_brokenBar() const { return String(u8"¦"); }
		String s_cartesianProduct() const { return String(u8"×"); }
		String s_degreeSymbol() const { return String(u8"°"); }
		String s_equalSign() const { return String(u8"="); }
		String s_greaterThanSign() const { return String(u8">"); }
		String s_lessThanSign() const { return String(u8"<"); }
		String s_microSign() const { return String(u8"µ"); }
		String s_minusSign() const { return String(u8"-"); }
		String s_negation() const { return String(u8"¬"); }
		String s_numberSign() const { return String(u8"#"); }
		String s_obelus() const { return String(u8"÷"); }
		String s_ordf() const { return String(u8"ª"); }
		String s_ordm() const { return String(u8"º"); }
		String s_plusSign() const { return String(u8"+"); }
		String s_plusMinusSign() const { return String(u8"±"); }
		String s_percentSign() const { return String(u8"%"); }
		String s_slash() const { return String(u8"/"); }
		String s_verticalBar() const { return String(u8"|"); }

	};
	
	
};


}


#endif
