/**************************************************************************
 * Copyright (c) 2013 Anya Helene Bagge
 * Copyright (c) 2013 University of Bergen
 * 
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 * 
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 * 
 * See the file COPYRIGHT for more information.
 * 
 * Contributors:
 * * Anya Helene Bagge
 * 
 *************************************************************************/
#ifndef _MAGNOLIA_PRELUDE_ASSERT_HXX
#define _MAGNOLIA_PRELUDE_ASSERT_HXX

#include <iostream>

namespace Magnolia {
  namespace Assert {
    void axiom_assert(bool cond, const char* msg, const char* src, const char* loc) {
        if(!cond) {
                if(*loc != '\0')
                        std::cerr << loc << ": ";
                std::cerr << "Assertion failed";
                if(*src != '\0')
                        std::cerr << ": " << src;
                std::cerr << std::endl;
                if(*msg != '\0')
                        std::cerr << "    " << msg << std::endl;
        }
    }

    template<typename T, typename U>
    bool equal(T a, U b) { /*  std::cerr << a << " == " << b << " = " << (a == b) << std::endl; */ return a == b; }

    template<typename T, typename U>
    bool notEqual(T a, U b) { /* std::cerr << a << " != " << b << " = " << (a != b) << std::endl; */ return !(a == b); }

    void guardFailed(const char* msg, const char* src, const char* loc);
    template<typename T>
    const T& exprGuardFailed(const T& val, const char* msg, const char* src, const char* loc);
  }

  bool implies(bool a, bool b) {
  	return !a || b;
  }
}
