/**************************************************************************
 * Copyright (c) 2010-2013 Anya Helene Bagge
 * Copyright (c) 2010-2013 University of Bergen
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version. See http://www.gnu.org/licenses/
 * 
 * 
 * See the file COPYRIGHT for more information.
 * 
 * Contributors:
 * * Anya Helene Bagge
 * 
 *************************************************************************/
package org.magnolialang.compiler;

import java.util.Arrays;

import org.rascalmpl.value.ISourceLocation;
import org.rascalmpl.value.IString;
import org.rascalmpl.value.IValueFactory;
import org.magnolialang.infra.Infra;
import org.nuthatchery.pica.rascal.IEvaluatorPool;
import org.rascalmpl.values.ValueFactoryFactory;

public final class GenerateFromGrammar {
	public static final IValueFactory VF = ValueFactoryFactory.getValueFactory();


	public static void main(String[] args) {

		IEvaluatorPool eval = Infra.get().getEvaluatorPool("Generate from syntax", Arrays.asList("org::magnolialang::compiler::Util", "org::magnolialang::compiler::Table2X"));

		eval.call("hello");

		IString language = VF.string(args[0]);
		ISourceLocation tableFile = VF.sourceLocation(args[1]);
		ISourceLocation rascalOutputDir = VF.sourceLocation(args[2]);
		ISourceLocation prettyOutputDir = VF.sourceLocation(args[3]);
		IString rascalPackage = VF.string(args[4]);

		eval.call("generateFromSyntax", language, tableFile, rascalOutputDir, prettyOutputDir, rascalPackage);

	}


	private GenerateFromGrammar() {

	}
}
