/**************************************************************************
 * Copyright (c) 2011-2013 Anya Helene Bagge
 * Copyright (c) 2011-2013 University of Bergen
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version. See http://www.gnu.org/licenses/
 * 
 * 
 * See the file COPYRIGHT for more information.
 * 
 * Contributors:
 * * Anya Helene Bagge
 * 
 *************************************************************************/
package org.magnolialang.eclipse.commands;

import org.eclipse.core.commands.AbstractHandler;
import org.eclipse.core.commands.ExecutionEvent;
import org.eclipse.core.commands.ExecutionException;
import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.core.runtime.IStatus;
import org.eclipse.core.runtime.Status;
import org.eclipse.core.runtime.jobs.Job;
import io.usethesource.impulse.editor.UniversalEditor;
import org.eclipse.ui.IEditorPart;
import org.eclipse.ui.handlers.HandlerUtil;
import org.magnolialang.eclipse.MagnoliaPlugin;
import org.rascalmpl.eclipse.nature.RascalMonitor;
import org.rascalmpl.eclipse.nature.WarningsToMarkers;
import org.rascalmpl.debug.IRascalMonitor;
import org.rascalmpl.interpreter.control_exceptions.Throw;

public class GenerateRandomProgram extends AbstractHandler {
	@Override
	public Object execute(final ExecutionEvent event) throws ExecutionException {
		final IEditorPart editorPart = HandlerUtil.getActiveEditor(event);
		if(editorPart instanceof UniversalEditor) {
			try {

				Job job = new Job("Generate Random Program") {
					@Override
					public boolean belongsTo(Object obj) {
						return obj == MagnoliaPlugin.JOB_FAMILY_MAGNOLIA;
					}


					@Override
					protected IStatus run(IProgressMonitor monitor) {
						IRascalMonitor rm = new RascalMonitor(monitor, new WarningsToMarkers());
						rm.startJob("Generate random program");
						RefreshHandler.autoRefresh(event);

						System.out.println("----------------------------------------------------------------------------------------------------------------------------------------");

						try {
							//final RascalInterpreter eval = RascalInterpreter.getInstance();

							//IConstructor foo = (IConstructor) eval.call("makeRandomProgram", "import org::magnolialang::magnolia::random::RandomPrograms;");

							//String yield = TermAdapter.yield(foo, new MagnoliaSkin(), false);
							//Editor.edit(yield, "/random/random.mg");
						}
						catch(Throw t) {
							System.err.println(t);
						}
						catch(Throwable t) { // NOPMD by anya on 1/5/12 3:50 AM
							t.printStackTrace();
						}

						// compiler.visualize();
						System.out.println("Done!!");
						rm.endJob(true);
						monitor.done();
						return Status.OK_STATUS;
					}

				};
				job.schedule();

			}
			catch(final Throwable e1) { // NOPMD by anya on 1/5/12 3:50 AM
				e1.printStackTrace();
			}
		}
		return null;
	}
}
