/**************************************************************************
 * Copyright (c) 2012-2014 Anya Helene Bagge
 * Copyright (c) 2012-2014 University of Bergen
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version. See http://www.gnu.org/licenses/
 * 
 * 
 * See the file COPYRIGHT for more information.
 * 
 * Contributors:
 * * Anya Helene Bagge
 * 
 *************************************************************************/
package org.magnolialang.eclipse.commands;

import org.eclipse.core.commands.AbstractHandler;
import org.eclipse.core.commands.ExecutionEvent;
import org.eclipse.core.commands.ExecutionException;
import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.core.runtime.IStatus;
import org.eclipse.core.runtime.Status;
import org.eclipse.core.runtime.jobs.Job;
import io.usethesource.impulse.editor.UniversalEditor;
import io.usethesource.impulse.parser.IParseController;
import org.rascalmpl.value.IConstructor;
import org.eclipse.ui.IEditorPart;
import org.eclipse.ui.handlers.HandlerUtil;
import org.magnolialang.eclipse.MagnoliaPlugin;
import org.magnolialang.errors.CompilationErrorException;
import org.nuthatchery.pica.errors.ImplementationError;
import org.rascalmpl.eclipse.nature.RascalMonitor;
import org.rascalmpl.eclipse.nature.WarningsToMarkers;
import org.rascalmpl.debug.IRascalMonitor;

public class RunStaticTests extends AbstractHandler {
	@Override
	public Object execute(final ExecutionEvent event) throws ExecutionException {
		final IEditorPart editorPart = HandlerUtil.getActiveEditor(event);
		if(editorPart instanceof UniversalEditor) {
			try {

				System.out.println("---------------------------------------------------------------------------------------------------------------------------------------");
				final IParseController parseCtrl = CommandUtil.getParseController(editorPart);
				final IConstructor symbol = CommandUtil.getModuleId(parseCtrl);
				Job job = new Job("Run Static Tests") {
					@Override
					public boolean belongsTo(Object obj) {
						return obj == MagnoliaPlugin.JOB_FAMILY_MAGNOLIA;
					}


					@Override
					protected IStatus run(IProgressMonitor monitor) {
						IRascalMonitor rm = new RascalMonitor(monitor, new WarningsToMarkers());
						rm.startJob("Run Static Tests");
						RefreshHandler.autoRefresh(event);

						System.out.println("Run Static Tests: " + symbol);

						// IList contents = (IList) ((IConstructor) compiler.getFact(rm, MagnoliaFacts.Type_Contents, symbol)).get("val");

						try {
							throw new ImplementationError("Not implemented");
							/* TODO: IValue result = compiler.getFact(rm, MagnoliaFacts.Type_TestReport, mutKey);
							if(result instanceof IConstructor) {
								IValue _errors = ((IConstructor) result).get("errors");
								ISet errors = (ISet) _errors;
								for(IValue _mark : errors) {
									if(_mark instanceof IConstructor) {
										System.out.println(((IConstructor) _mark).get("message"));
									}
								}
							}
							 */
						}
						catch(final CompilationErrorException ce) {
							ce.printStackTrace();
							// manager.reportError(ce);
						}
						catch(Throwable t) { // NOPMD by anya on 1/5/12 3:51 AM
							t.printStackTrace();
						}

						CommandUtil.commitMarks(parseCtrl);
						// compiler.visualize();
						System.out.println("Done!!");
						rm.endJob(true);
						monitor.done();
						return Status.OK_STATUS;
					}

				};
				job.schedule();
			}
			catch(final Throwable e1) { // NOPMD by anya on 1/5/12 3:51 AM
				e1.printStackTrace();
			}
		}
		return null;
	}
}
