/**************************************************************************
 * Copyright (c) 2012-2014 Anya Helene Bagge
 * Copyright (c) 2012-2014 University of Bergen
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version. See http://www.gnu.org/licenses/
 * 
 * 
 * See the file COPYRIGHT for more information.
 * 
 * Contributors:
 * * Anya Helene Bagge
 * 
 *************************************************************************/
package org.magnolialang.eclipse.commands;

import org.eclipse.core.commands.AbstractHandler;
import org.eclipse.core.commands.Command;
import org.eclipse.core.commands.ExecutionEvent;
import org.eclipse.core.commands.ExecutionException;
import org.eclipse.core.commands.State;
import org.eclipse.ui.PlatformUI;
import org.eclipse.ui.commands.ICommandService;
import org.eclipse.ui.handlers.HandlerUtil;
import org.eclipse.jdt.annotation.Nullable;

public class ToggleHandler extends AbstractHandler { // NOPMD by anya on 1/5/12 3:52 AM
	public static final String COMMAND_AUTO_RELOAD = "magnolia_eclipse.commands.AutoReload";
	public static final String COMMAND_AUTO_REFRESH = "magnolia_eclipse.commands.AutoRefresh";


	public static boolean enabled(String commandId) {
		final ICommandService commandService = (ICommandService) PlatformUI.getWorkbench().getService(ICommandService.class);
		final Command command = commandService.getCommand(commandId);
		final State state = command.getState("org.eclipse.ui.commands.toggleState");
		return (Boolean) state.getValue();
	}


	public static void setState(String commandId, boolean newState) {
		final ICommandService commandService = (ICommandService) PlatformUI.getWorkbench().getService(ICommandService.class);
		final Command command = commandService.getCommand(commandId);
		final State state = command.getState("org.eclipse.ui.commands.toggleState");
		state.setValue(Boolean.valueOf(newState));
	}


	@Override
	@Nullable
	public Object execute(final ExecutionEvent event) throws ExecutionException {
		HandlerUtil.toggleCommandState(event.getCommand());
		return null;
	}
}
