/**************************************************************************
 * Copyright (c) 2010-2014 Anya Helene Bagge
 * Copyright (c) 2010-2014 University of Bergen
 *
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version. See http://www.gnu.org/licenses/
 *
 *
 * See the file COPYRIGHT for more information.
 *
 * Contributors:
 * * Anya Helene Bagge
 *
 *************************************************************************/
package org.magnolialang.eclipse.editor;

import io.usethesource.impulse.editor.UniversalEditor;
import org.eclipse.jface.action.Action;
import org.eclipse.jface.action.IAction;
import org.eclipse.jface.text.IDocument;
import org.eclipse.jface.text.source.ISourceViewer;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.ui.texteditor.ITextEditorActionConstants;
import org.eclipse.ui.texteditor.ITextEditorActionDefinitionIds;

/**
 * @author anya
 *
 */
public class MagnoliaEditor extends UniversalEditor {
	@Override
	public void createPartControl(final Composite parent) {
		super.createPartControl(parent);
		if(getParseController() != null) {
			MagnoliaParseController ctrl = (MagnoliaParseController) getParseController();
			ctrl.setEditor(this);
			ISourceViewer sourceViewer = getSourceViewer();
			sourceViewer.setTextHover(new HoverHelper(ctrl), IDocument.DEFAULT_CONTENT_TYPE);
		}

	}


	@Override
	public void dispose() {
		((MagnoliaParseController) getParseController()).dispose();
		super.dispose();
	}


	@Override
	protected void createActions() {
		super.createActions();

		final IAction action = new MyAction();
		action.setActionDefinitionId(ITextEditorActionDefinitionIds.SHOW_INFORMATION);

		setAction(ITextEditorActionConstants.SHOW_INFORMATION, action);
	}


	@Override
	protected void initializeKeyBindingScopes() {
		setKeyBindingScopes(new String[] { "magnolia_eclipse.magnolia.sourceEditorScope" });
	}


	private final static class MyAction extends Action {
	}
}
