/**************************************************************************
 * Copyright (c) 2012-2013 Anya Helene Bagge
 * Copyright (c) 2012-2013 University of Bergen
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version. See http://www.gnu.org/licenses/
 * 
 * 
 * See the file COPYRIGHT for more information.
 * 
 * Contributors:
 * * Anya Helene Bagge
 * 
 *************************************************************************/
package org.magnolialang.eclipse.tests;

import static org.junit.Assert.assertNotNull;

import java.io.ByteArrayInputStream;
import java.io.UnsupportedEncodingException;

import org.eclipse.core.resources.IFile;
import org.eclipse.core.resources.IFolder;
import org.eclipse.core.resources.IProject;
import org.eclipse.core.resources.IProjectDescription;
import org.eclipse.core.resources.IWorkspace;
import org.eclipse.core.resources.ResourcesPlugin;
import org.eclipse.core.runtime.CoreException;
import org.eclipse.core.runtime.NullProgressMonitor;
import org.junit.Test;
import org.magnolialang.eclipse.MagnoliaNature;
import org.magnolialang.eclipse.MagnoliaPlugin;
import org.magnolialang.infra.Infra;

public class HelloEclipse {

	@Test
	public final void test() {
		System.err.println("Hello, Eclipse!");
		assertNotNull(MagnoliaPlugin.getInstance());
		assertNotNull(Infra.getWorkspaceManager());
		IWorkspace workspace = ResourcesPlugin.getWorkspace();

		NullProgressMonitor monitor = new NullProgressMonitor();
		IProject project = workspace.getRoot().getProject("TestProject");
		try {
			IProjectDescription desc = workspace.newProjectDescription("TestProject");
			desc.setNatureIds(new String[] { MagnoliaNature.NATURE_ID });
			project.create(desc, monitor);
			project.open(monitor);
			IFolder src = project.getFolder("src");
			src.create(true, true, monitor);
			IFile foo = src.getFile("Foo.mg");
			foo.create(new ByteArrayInputStream("".getBytes("UTF-8")), true, monitor);
			IFile bar = src.getFile("Bar.mg");
			bar.create(new ByteArrayInputStream("".getBytes("UTF-8")), true, monitor);
			IFile baz = src.getFile("Baz.mg");
			baz.create(new ByteArrayInputStream("".getBytes("UTF-8")), true, monitor);
			bar.delete(true, monitor);
		}
		catch(CoreException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		catch(UnsupportedEncodingException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

	}

}
