/**************************************************************************
 * Copyright (c) 2012-2013 Anya Helene Bagge
 * Copyright (c) 2012-2013 University of Bergen
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version. See http://www.gnu.org/licenses/
 * 
 * 
 * See the file COPYRIGHT for more information.
 * 
 * Contributors:
 * * Anya Helene Bagge
 * 
 *************************************************************************/
package org.magnolialang.eclipse.tests;

import org.eclipse.core.resources.IProject;
import org.eclipse.core.resources.IProjectDescription;
import org.eclipse.core.resources.IWorkspace;
import org.eclipse.core.resources.ResourcesPlugin;
import org.eclipse.core.runtime.CoreException;
import org.magnolialang.eclipse.MagnoliaNature;
import org.magnolialang.eclipse.MagnoliaPlugin;

public class ProjectUtil {

	public static IProject createProject(String projectName, boolean deleteIfExists) throws Exception {
		MagnoliaPlugin.getOrStartInstance();
		IWorkspace workspace = ResourcesPlugin.getWorkspace();
		IProject project = workspace.getRoot().getProject(projectName);

		if(project.exists()) {
			if(deleteIfExists) {
				try {
					project.delete(true, null);
				}
				catch(CoreException e) {
					e.printStackTrace();
				}
			}
			else {
				return project;
			}
		}
		IProjectDescription desc = workspace.newProjectDescription(projectName);
		desc.setNatureIds(new String[] { MagnoliaNature.NATURE_ID });
		project.create(desc, null);
		project.open(null);
		return project;
	}

}
