/**************************************************************************
 * Copyright (c) 2012-2013 Anya Helene Bagge
 * Copyright (c) 2012-2013 University of Bergen
 *
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version. See http://www.gnu.org/licenses/
 *
 *
 * See the file COPYRIGHT for more information.
 *
 * Contributors:
 * * Anya Helene Bagge
 *
 *************************************************************************/
package org.magnolialang.eclipse.util;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Collections;

import org.rascalmpl.value.IConstructor;
import org.rascalmpl.value.ISourceLocation;
import org.magnolialang.magnolia.resources.IMagnoliaPackage;
import org.nuthatchery.pica.resources.regions.IOffsetLength;
import org.nuthatchery.pica.tasks.ITaskMonitor;
import org.nuthatchery.pica.util.Pair;

public class XRefHelper {
	public static Collection<Pair<IOffsetLength, IConstructor>> getXRefs(IMagnoliaPackage pkg, int offset, ITaskMonitor tm) {
		if(pkg == null) {
			return Collections.EMPTY_LIST;
		}
		Collection<Pair<IOffsetLength, Object>> refs = pkg.getXRefs(tm);
		Collection<Pair<IOffsetLength, IConstructor>> foundXRefs = new ArrayList<>();
		for(Pair<IOffsetLength, Object> pair : refs) {
			IOffsetLength loc = pair.getFirst();

			if(loc.getOffset() <= offset && offset < loc.getOffset() + loc.getLength()) {
				foundXRefs.add(new Pair<>(pair.getFirst(), (IConstructor) pair.getSecond()));
			}
		}
		return foundXRefs;
	}

}
