/**************************************************************************
 * Copyright (c) 2010-2013 Anya Helene Bagge
 * Copyright (c) 2010-2013 University of Bergen
 *
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version. See http://www.gnu.org/licenses/
 *
 *
 * See the file COPYRIGHT for more information.
 *
 * Contributors:
 * * Anya Helene Bagge
 *
 *************************************************************************/
package org.magnolialang.errors;

import org.rascalmpl.value.ISourceLocation;
import org.nuthatchery.pica.errors.ImplementationError;
import org.nuthatchery.pica.rascal.RascalUtil;

public class SymbolNotFoundError extends ImplementationError {
	private static final long serialVersionUID = -8759252850158651024L;


	public SymbolNotFoundError(String symbolName, ISourceLocation loc) {
		super(symbolName, RascalUtil.toCodeRegion(loc));
	}


	public SymbolNotFoundError(String symbolName, String stage) {
		super(symbolName + " (in " + stage + ")");
	}


	public SymbolNotFoundError(String symbolName, String stage, Throwable cause) {
		super(symbolName + " (in " + stage + ")", cause);
	}

}
