/**************************************************************************
 * Copyright (c) 2010-2013 Anya Helene Bagge
 * Copyright (c) 2010-2013 University of Bergen
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version. See http://www.gnu.org/licenses/
 * 
 * 
 * See the file COPYRIGHT for more information.
 * 
 * Contributors:
 * * Anya Helene Bagge
 * 
 *************************************************************************/
package org.magnolialang.errors;

import org.rascalmpl.value.IValue;
import org.nuthatchery.pica.errors.ErrorMarkers;

public class SyntaxErrorException extends CompilationErrorException {
	private static final long serialVersionUID = -7691582352713906102L;
	private static final String ERROR_TYPE = "syntax error";


	public SyntaxErrorException(final String message) {
		super(message);
	}


	public SyntaxErrorException(final String message, final IValue locOrTree) {
		super(message, locOrTree);
	}


	public SyntaxErrorException(final String message, final Throwable cause) {
		super(message, cause);
	}


	public SyntaxErrorException(final String message, final Throwable cause, final IValue locOrTree) {
		super(message, cause, locOrTree);
	}


	@Override
	public String getErrorType() {
		final Throwable cause = getCause();
		if(cause == null) {
			return ERROR_TYPE;
		}
		else {
			return cause.getMessage();
		}
	}


	@Override
	public String getMarkerType() {
		return ErrorMarkers.TYPE_SYNTAX;
	}
}
