/**************************************************************************
 * Copyright (c) 2014 Anya Helene Bagge
 * Copyright (c) 2014 University of Bergen
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version. See http://www.gnu.org/licenses/
 * 
 * 
 * See the file COPYRIGHT for more information.
 * 
 * Contributors:
 * * Anya Helene Bagge
 * 
 *************************************************************************/
package org.magnolialang.magnolia.evaluator.callables;

import org.rascalmpl.value.IConstructor;
import org.rascalmpl.value.IMap;
import org.magnolialang.magnolia.Magnolia;
import org.magnolialang.magnolia.evaluator.IEvaluationContext;
import org.magnolialang.magnolia.evaluator.types.Type;
import org.magnolialang.magnolia.evaluator.values.Value;
import org.nuthatchery.pica.terms.TermAdapter;

public abstract class Callable extends Value {

	public abstract Object call(IEvaluationContext context, IMap env, IConstructor argList);


	public abstract IConstructor getParamMode(int i);


	public abstract IConstructor getParamName(int i);


	public abstract Type getParamType(int i);


	@Override
	public boolean isCallable() {
		return true;
	}


	public abstract int numParams();


	@Override
	public String toString() {
		StringBuffer buf = new StringBuffer();
		buf.append(getKind());
		buf.append(" ");
		buf.append(getName());
		buf.append("(");
		int n = numParams();
		for(int i = 0; i < n; i++) {
			if(i > 0) {
				buf.append(", ");
			}
			buf.append(TermAdapter.yieldTerm(getParamMode(i), false));
			buf.append(" ");
			buf.append(Magnolia.yieldName(getParamName(i)));
		}
		buf.append(")");
		return buf.toString();
	}
}
