/**************************************************************************
 * Copyright (c) 2014 Anya Helene Bagge
 * Copyright (c) 2014 University of Bergen
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version. See http://www.gnu.org/licenses/
 * 
 * 
 * See the file COPYRIGHT for more information.
 * 
 * Contributors:
 * * Anya Helene Bagge
 * 
 *************************************************************************/
package org.magnolialang.magnolia.evaluator.callables;

import org.rascalmpl.value.IConstructor;
import org.rascalmpl.value.IMap;
import org.magnolialang.magnolia.evaluator.AlgoEvaluator;
import org.magnolialang.magnolia.evaluator.types.ExternalModule;
import org.magnolialang.magnolia.evaluator.types.Type;

public class ExternalFunction extends ExternalOperation {

	private final Type retType;


	public ExternalFunction(ExternalModule module, IConstructor opName, IConstructor paramList, IConstructor retType, IMap env) {
		super(module, opName, paramList, env);
		this.retType = AlgoEvaluator.lookupType(retType, env);
	}


	@Override
	public String getKind() {
		return "function";
	}


	@Override
	public boolean isFunction() {
		return true;
	}
}
