/**************************************************************************
 * Copyright (c) 2014 Anya Helene Bagge
 * Copyright (c) 2014 University of Bergen
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version. See http://www.gnu.org/licenses/
 * 
 * 
 * See the file COPYRIGHT for more information.
 * 
 * Contributors:
 * * Anya Helene Bagge
 * 
 *************************************************************************/
package org.magnolialang.magnolia.evaluator.callables;

import org.rascalmpl.value.IConstructor;
import org.rascalmpl.value.IMap;
import org.magnolialang.magnolia.evaluator.IEvaluationContext;
import org.magnolialang.magnolia.evaluator.errors.EvaluationError;
import org.nuthatchery.pica.terms.TermAdapter;

public class Procedure extends InternalOperation {

	public Procedure(IConstructor procDef, IMap env) {
		super(procDef, env);

		if(!TermAdapter.getName(clause).equals("ProcClause")) {
			throw new EvaluationError("Not a function");
		}
	}


	@Override
	public Object call(IEvaluationContext ctx, IMap env, IConstructor argList) {
		env = bindArguments(ctx, env, argList);

		IConstructor body = getBody();

		return ctx.getEvaluator().evalStatDefBody(body, env, ctx);
	}


	@Override
	public String getKind() {
		return "procedure";
	}


	@Override
	public boolean isProcedure() {
		return true;
	}

}
