/**************************************************************************
 * Copyright (c) 2014 Anya Helene Bagge
 * Copyright (c) 2014 University of Bergen
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version. See http://www.gnu.org/licenses/
 * 
 * 
 * See the file COPYRIGHT for more information.
 * 
 * Contributors:
 * * Anya Helene Bagge
 * 
 *************************************************************************/
// WARNING: this file is autogenerated! just copy it and adapt to your needs
package org.magnolialang.magnolia.grammar;

import org.rascalmpl.value.IConstructor;

public interface AlgoVisitor<R, E> {

	R evalExpr_Apply(IConstructor arg0, IConstructor arg1, E env);


	R evalExpr_BlockExpr(IConstructor arg0, E env);


	R evalExpr_DotOp(IConstructor arg0, IConstructor arg1, E env);


	R evalExpr_Expect(IConstructor arg0, IConstructor arg1, E env);


	R evalExpr_Guard(IConstructor arg0, IConstructor arg1, E env);


	R evalExpr_IfThenElseExpr(IConstructor arg0, IConstructor arg1, IConstructor arg2, E env);


	R evalExpr_ListCons(IConstructor arg0, E env);


	R evalExpr_Literal(IConstructor arg0, E env);


	R evalExpr_Literal(IConstructor arg0, IConstructor arg1, E env);


	R evalExpr_Recover(IConstructor arg0, IConstructor arg1, E env);


	R evalExpr_Struct(IConstructor arg0, IConstructor arg1, E env);


	R evalExpr_Tuple(IConstructor arg0, E env);


	R evalExpr_TypeExpr(IConstructor arg0, E env);


	R evalExpr_Undefined(IConstructor arg0, E env);


	R evalExpr_Var(IConstructor arg0, E env);


	R evalExprDeclarative_FunClause(IConstructor arg0, IConstructor arg1, IConstructor arg2, E env);


	R evalExprDeclarative_VarClause(IConstructor arg0, IConstructor arg1, E env);


	R evalExprDefBody_Body(IConstructor arg0, E env);


	R evalExprDefBody_EmptyBody(E env);


	R evalFun_ExternalFun(IConstructor arg0, IConstructor arg1, IConstructor arg2, IConstructor arg3, IConstructor arg4, E env);


	R evalFun_Fun(IConstructor arg0, E env);


	R evalFun_FunOf(IConstructor arg0, IConstructor arg1, E env);


	R evalInitSpec_Field(IConstructor arg0, IConstructor arg1, E env);


	R evalIntegerLiteral_DecimalIntegerLiteral(IConstructor decimal, E env);


	R evalIntegerLiteral_HexIntegerLiteral(IConstructor hex, E env);


	R evalIntegerLiteral_OctalIntegerLiteral(IConstructor octal, E env);


	R evalLetClause_VarDecl(IConstructor arg0, IConstructor arg1, IConstructor arg2, IConstructor arg3, E env);


	R evalProc_ExternalProc(IConstructor arg0, IConstructor arg1, IConstructor arg2, IConstructor arg3, E env);


	R evalProc_Proc(IConstructor arg0, E env);


	R evalProc_ProcOf(IConstructor arg0, E env);


	R evalStat_Assert(IConstructor arg0, IConstructor arg1, E env);


	R evalStat_Assign(IConstructor arg0, IConstructor arg1, E env);


	R evalStat_Assume(IConstructor arg0, IConstructor arg1, E env);


	R evalStat_Break(E env);


	R evalStat_Call(IConstructor arg0, IConstructor arg1, E env);


	R evalStat_Expect(IConstructor arg0, IConstructor arg1, E env);


	R evalStat_For(IConstructor arg0, IConstructor arg1, IConstructor arg2, E env);


	R evalStat_Guard(IConstructor arg0, IConstructor arg1, E env);


	R evalStat_If(IConstructor arg0, IConstructor arg1, IConstructor arg2, E env);


	R evalStat_Let(IConstructor arg0, IConstructor arg1, E env);


	R evalStat_Nop(E env);


	R evalStat_Return(E env);


	R evalStat_Return(IConstructor arg0, E env);


	R evalStat_ReturnBlock(IConstructor arg0, E env);


	R evalStat_While(IConstructor arg0, IConstructor arg1, E env);


	R evalStat_Yield(IConstructor arg0, E env);


	R evalStatDefBody_Body(IConstructor arg0, E env);


	R evalStatDefBody_EmptyBody(E env);


	R evalStringLiteral_StringLiteral(IConstructor string, E env);

}
