/**************************************************************************
 * Copyright (c) 2011-2014 Anya Helene Bagge
 * Copyright (c) 2011-2014 University of Bergen
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version. See http://www.gnu.org/licenses/
 * 
 * 
 * See the file COPYRIGHT for more information.
 * 
 * Contributors:
 * * Anya Helene Bagge
 * 
 *************************************************************************/
module org::magnolialang::magnolia::lib::MagnoliaUtil
import IO;
import org::magnolialang::magnolia::AbstractSyntax;
import org::magnolialang::magnolia::MagnoliaFacts;
import org::nuthatchery::pica::terms::Terms;
import org::magnolialang::compiler::Util;

public AST defInfoToAST(DefInfo info) {
	AST result;
	switch(info.kind) {
		case "package":
			result = MagnoliaTree(PackageHead(info.qName, seq(info.attrs)), info.body);
		case "program":
			result = TopDefine(info.decl, seq(info.attrs), info.body); 
		case "implementation":
			result = TopDefine(info.decl, seq(info.attrs), info.body); 
		case "renaming":
			result = TopDefine(info.decl, seq(info.attrs), info.body); 
		case "concept":
			result = TopDefine(info.decl, seq(info.attrs), info.body); 
		case "satisfaction":
			result = TopDefine(info.decl, seq(info.attrs), info.body);
		case "axiom":
			result = Define(info.decl, seq(info.attrs), info.body);
		case "function":
			result = Define(info.decl, seq(info.attrs), info.body);
		case "test":
			result = Define(info.decl, seq(info.attrs), info.body);
		default:
			throw "Unknown kind <info.kind>"; 
	}
	return result;
}

