/**************************************************************************
 * Copyright (c) 2011-2014 Anya Helene Bagge
 * Copyright (c) 2011-2014 University of Bergen
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version. See http://www.gnu.org/licenses/
 * 
 * 
 * See the file COPYRIGHT for more information.
 * 
 * Contributors:
 * * Anya Helene Bagge
 * 
 *************************************************************************/
module org::magnolialang::magnolia::lib::TestNames

import org::magnolialang::magnolia::lib::Names;


public test bool qualifyTest(AST name) {
	if(isQualifiedName(name))
		return qualify(qualifierOf(name), unqualify(name)) == name;
	else
		return true;
}

public test bool qualifyTest(AST n1, AST n2) {
	if(isQualifiedName(n1) && !isQualifiedName(n2))
		return qualifier(qualify(n1, n2)) == n1
			&& unqualify(qualify(n1, n2)) == n2;
	else
		return true;
}

public test bool sameKindNameTest(AST n1, AST n2, AST n3) {
	if(isName(n1) && isName(n2) && isName(n3)) {
		return sameKindName(n1, n1) // reflexive
			&& sameKindName(n1, n2) == sameKindName(n2, n1) // symmetric
			&& (!sameKindName(n1, n2) || !sameKindName(n2, n3) || sameKindName(n1, n3)); // transitive
	}
	return true;
}