/**************************************************************************
 * Copyright (c) 2012-2014 Anya Helene Bagge
 * Copyright (c) 2012-2014 University of Bergen
 *
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version. See http://www.gnu.org/licenses/
 *
 *
 * See the file COPYRIGHT for more information.
 *
 * Contributors:
 * * Anya Helene Bagge
 *
 *************************************************************************/
package org.magnolialang.magnolia.resources;

import java.util.Collection;

import org.rascalmpl.value.IConstructor;
import org.nuthatchery.pica.resources.IProjectManager;
import org.nuthatchery.pica.resources.managed.IManagedCodeUnit;
import org.nuthatchery.pica.resources.managed.IManagedContainer;
import org.nuthatchery.pica.tasks.ITaskMonitor;

public interface IMagnoliaPackage extends IManagedContainer, IMagnoliaCodeUnit {

	void addMarks(IConstructor result, String source, IManagedCodeUnit context);


	void clearMarks(String source, IManagedCodeUnit context);


	@Override
	Collection<IMagnoliaModule> getChildren(ITaskMonitor tm);


	IProjectManager getManager();


	IConstructor getPackageEnv(ITaskMonitor tm);
}
