/**************************************************************************
 * Copyright (c) 2012-2013 Anya Helene Bagge
 * Copyright (c) 2012-2013 University of Bergen
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version. See http://www.gnu.org/licenses/
 * 
 * 
 * See the file COPYRIGHT for more information.
 * 
 * Contributors:
 * * Anya Helene Bagge
 * 
 *************************************************************************/
module org::magnolialang::magnolia::typechecker::algo::Overload

import org::magnolialang::magnolia::AbstractSyntax;
import org::magnolialang::magnolia::lib::MagnoliaCompileLib;
import org::magnolialang::magnolia::lib::Environment;
import org::magnolialang::magnolia::typechecker::algo::Types;
import org::nuthatchery::pica::terms::Terms;
import List;

public set[AST] overload(set[AST] cands, list[AST] args, Env env) {
	set[AST] olCands = {};
	forLoop: for(c <- cands) {
		params = paramList(c, env);
		
		if(size(params) == size(args)) {
			for(i <- index(params)) {
				if(!isAssignable(params[i], args[i], env)) {
					if(DEBUG_TYPECHECK)
						termPrintln("Args don\'t match:\n     ", params[i], "\n  != ", args[i]);
					continue forLoop;
				}
			}
			olCands += c;
		}
	}
	
	return olCands;
}

list[AST] paramList(FunName(_, seq(ps), _), Env env) {
	return [t | AnonParam(p, t) <- ps];
}

list[AST] paramList(ProcName(_, seq(ps)), Env env) {
	return [t | AnonParam(p, t) <- ps];
}

list[AST] paramList(VarName(_, _), Env env) {
	return [];
}

list[AST] paramList(AST tree, Env env) {
	termPrintln("paramList: ", tree);
	env = errorMark(env, "Internal Compiler Error: Overload::paramList: failed to extract parameter list from <consOf(tree)>", locOf(tree));
	return [];
}
