/**************************************************************************
 * Copyright (c) 2010-2013 Anya Helene Bagge
 * Copyright (c) 2010-2013 University of Bergen
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version. See http://www.gnu.org/licenses/
 * 
 * 
 * See the file COPYRIGHT for more information.
 * 
 * Contributors:
 * * Anya Helene Bagge
 * 
 *************************************************************************/
module org::magnolialang::metaxa::Banana

import org::magnolialang::metaxa::BuildMatch;
import org::nuthatchery::pica::terms::Terms;
import org::magnolialang::metaxa::Env;
import org::magnolialang::compiler::Util;
import List;
import Set;

public cmd mBanana(str name, rel[AST,AST] banana) {
	list[tuple[AST,cmd]] bananaConds = [];
	for(<from, to> <- banana) {
		vars = varsOf(to);
		list[cmd] cmds = [];
		for(v <- vars) {
			cmds += jAssign(q(v), jApply("banana",[q(v)]));
		}
		cmds += jReturn(q(to));
		bananaConds += <from, jBlock(cmds)>;
	}
	return jDef(name, [<"IConstructor", jVar("tree")>], mMatch(jVar("tree"), bananaConds));
}
 