/**************************************************************************
 * Copyright (c) 2010-2014 Anya Helene Bagge
 * Copyright (c) 2010-2014 University of Bergen
 *
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version. See http://www.gnu.org/licenses/
 *
 *
 * See the file COPYRIGHT for more information.
 *
 * Contributors:
 * * Anya Helene Bagge
 *
 *************************************************************************/
package org.magnolialang.metaxa;

import java.util.Arrays;

import org.rascalmpl.value.IListWriter;
import org.rascalmpl.value.IMapWriter;
import org.rascalmpl.value.ISourceLocation;
import org.rascalmpl.value.IString;
import org.rascalmpl.value.IValueFactory;
import org.magnolialang.infra.Infra;
import org.nuthatchery.pica.rascal.IEvaluatorPool;
import org.nuthatchery.pica.tasks.NullTaskMonitor;
import org.rascalmpl.values.ValueFactoryFactory;

public final class GenerateSyntaxEmbedding {
	public static final IValueFactory vf = ValueFactoryFactory.getValueFactory();


	private GenerateSyntaxEmbedding() {

	}


	public static void main(String[] args) {

		IListWriter sorts = vf.listWriter();
		String[] strings = new String[] { "Expr", "Stat", "Decl", "Type", "Var", "Identifier", "Name", "FunName", "ProcName", "SubClause", "ConceptExpr", "ImplExpr", "Morphism" };
		for(String s : strings) {
			sorts.append(vf.string(s));
		}
		IMapWriter listSeps = vf.mapWriter();
		listSeps.put(vf.string("Expr"), vf.string(","));
		listSeps.put(vf.string("Type"), vf.string(","));
		listSeps.put(vf.string("Identifier"), vf.string(","));
		listSeps.put(vf.string("Name"), vf.string(","));
		listSeps.put(vf.string("Var"), vf.string(","));

		ISourceLocation embeddingOutput = vf.sourceLocation(args[0]);
		IString moduleName = vf.string(args[1]);

		IEvaluatorPool pool = Infra.get().getEvaluatorPool("generate", Arrays.asList("org::magnolialang::metaxa::GenerateSyntaxEmbedding"));
		pool.call(new NullTaskMonitor(), "generate", embeddingOutput, moduleName, sorts.done(), listSeps.done());
	}
}
