/**************************************************************************
 * Copyright (c) 2010 Anya Helene Bagge
 * Copyright (c) 2010 University of Bergen
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version. See http://www.gnu.org/licenses/
 * 
 * 
 * See the file COPYRIGHT for more information.
 * 
 * Contributors:
 * * Anya Helene Bagge
 * 
 *************************************************************************/
module Expressions 
syntax Var
	= Var: Name 
	| Var: Name ":" Type ;

syntax Expr
	= Literal: Literal 
	| Value: Type "{" InitSpecList "}" 
	| FunApp: Fun ArgumentList 
	| Undefined: "_" 
	| Block: "{" Stat* "}" 
	| Type: ":" Type 
	| /*term(inject())*/ Var 
	| If: "if" Expr "then" Expr "else" Expr "end" 
	| Tuple: "(" ExprList ")" ;

syntax Fun
	= Fun0: Name 
	| F: "\\f" "(" Name ")" 
	| External: "\\external" "(" Identifier "," Name "," Name ")" ;

syntax InitSpec
	= InitSpec0: UnqName ":=" Expr ;

syntax Name
	= /*term(inject())*/ UnqName ;

syntax ArgumentList
	= ArgumentList0: "(" ExprList ")" ;

syntax InitSpecList
	= InitSpecList0: {InitSpec ","}* ;


