/**************************************************************************
 * Copyright (c) 2010 Anya Helene Bagge
 * Copyright (c) 2010 University of Bergen
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version. See http://www.gnu.org/licenses/
 * 
 * 
 * See the file COPYRIGHT for more information.
 * 
 * Contributors:
 * * Anya Helene Bagge
 * 
 *************************************************************************/
module MetaXa::SyntaxDef 
syntax BNFRule
	= SyntaxProd: SortName "=" {BNFTopExpr "|"}* ;

syntax SyntaxProd_Token
	= SyntaxProd_Token0: "\"" SYMBOL "\"" ;

syntax SyntaxProd_BNFTopExpr
	= AutoCons: "_" ":" SyntaxProd_BNFExpr* 
	| NoCons: SyntaxProd_BNFExpr* 
	| Cons: Cons ":" SyntaxProd_BNFExpr* ;

syntax ConstructSection
	= Syntax: "syntax" SyntaxRules ;

syntax Syntax_QuotedTokens
	= SyntaxTokens: "[+" Syntax_SimpleToken* "+]" ;

syntax SyntaxProd_BNFExpr
	= SyntaxProd_Token 
	| SortName 
	| SyntaxProd_BNFExpr0: "(" SyntaxProd_BNFExpr ")" 
	| Opt: SyntaxProd_BNFExpr "?" 
	| Iter: SyntaxProd_BNFExpr REP 
	| IterSep: "{" SyntaxProd_BNFExpr BNFToken "}" REP ;

syntax Syntax_SimpleToken
	= SyntaxProd_Token 
	| Sort 
	| Punct 
	| Keyword ;

syntax Syntax_SyntaxRule
	= SugarDef 
	| Quoted 
	| Syntax_QuotedTokens 
	| BNFRule ;

syntax Syntax_SyntaxRules
	= Syntax_SyntaxRules1: Syntax_SyntaxRule* "where" Syntax_SyntaxRule* 
	| Syntax_SyntaxRules0: Syntax_SyntaxRule* ;


