/**************************************************************************
 * Copyright (c) 2010-2013 Anya Helene Bagge
 * Copyright (c) 2010-2013 University of Bergen
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version. See http://www.gnu.org/licenses/
 * 
 * 
 * See the file COPYRIGHT for more information.
 * 
 * Contributors:
 * * Anya Helene Bagge
 * 
 *************************************************************************/
module org::magnolialang::metaxa::TestBuildMatch

import org::nuthatchery::pica::terms::Terms;
import org::magnolialang::metaxa::Env;
import org::magnolialang::compiler::Util;
import org::magnolialang::compiler::MetaMagnoliaAST;
import org::magnolialang::metaxa::BuildMatch;
import org::magnolialang::metaxa::Banana;
import Node;
import List;
import Set;
import IO;
import String;

data AST = UserSyntax0(AST, AST, AST);                                  // Stat ::= Expr "." Identifier "=" Expr ";"
data AST = UserSyntax1(AST, AST, AST);                                  // Stat ::= Identifier "[" {Expr ","}+ "]" "=" Expr ";"
data AST = UserSyntax2(AST);                                            // Expr ::= Name
data AST = UserSyntax3(AST, AST);                                       // Stat ::= "if" Expr "then" Stat* "end"
data AST = UserSyntax4(AST, AST);                                       // Stat ::= "if" "(" Expr ")" "{" Stat* "}"
data AST = UserSyntax5(AST, AST, AST);                                  // Stat ::= "if" "(" Expr ")" "{" Stat* "}" "else" "{" Stat* "}"

	
public void main() {
	try {
		env = newEnv();
		//expr = mMatch(jVar("foo"), 
		//   [<If(leaf("true"), var("t"), var("e")), jReturn(q(var("t")))>,
		//	<If(var("c"), var("t"), var("e")), jNop()>,
		//	<While(var("c"), var("body")), jNop()>]);
		expr = mBanana("myBanana", {
			<If(leaf("true"), var("t"), var("e")), var("t")>,
			<UserSyntax3(var("c"), var("t")),
				If(var("c"), var("t"), seq([]))>});
				
		println(expr);
		
		println(compileCmd(expr, newEnv()));
	}
	catch e: {
		println(e);
	}
}
