/**************************************************************************
 * Copyright (c) 2012-2013 Anya Helene Bagge
 * Copyright (c) 2012-2013 Tero Hasu
 * Copyright (c) 2012-2013 University of Bergen
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version. See http://www.gnu.org/licenses/
 * 
 * 
 * See the file COPYRIGHT for more information.
 * 
 * Contributors:
 * * Anya Helene Bagge
 * * Tero Hasu
 * 
 *************************************************************************/
package org.magnolialang.testutil;

import java.util.Collections;
import java.util.Map;

import org.rascalmpl.value.IValue;
import org.magnolialang.infra.ConsoleInfra;
import org.magnolialang.magnolia.Magnolia;
import org.rascalmpl.debug.IRascalMonitor;

public final class TestUtil {

	private static Map<String, Object> options = Collections.emptyMap();


	public static IValue callCompiler(String funName, IValue... args) {
		//System.err.println("call to " + funName);
		//System.err.println("number of arguments is " + args.length);
		return Magnolia.getInstance().getCompiler().call(funName, args);
	}


	public static Map<String, Object> getOptions() {
		return options;
	}


	public TestUtil() {
	}


	public IRascalMonitor getMonitor() {
		IRascalMonitor rm = getInfra().getMonitor();
		return rm;
	}


	ConsoleInfra getInfra() {
		return ConsoleInfra.getInfra();
	}

}
