;; E.g. (use 'org.magnolialang.testutil.rascal-shell :reload-all)
(ns org.magnolialang.testutil.rascal-shell
  (:use org.magnolialang.testutil.core)
  (:import
   (org.magnolialang.testutil RascalShell))
  (:gen-class))

;; E.g. lein run -m org.magnolialang.testutil.rascal-shell --z x y
;; or rather
;;   lein run -m org.magnolialang.testutil.rascal-shell org::nuthatchery::pgf::rascal::tests::TestFmtEngine
(defn -main [& args]
  (init-compiler)
  (let [compiler (.getCompiler tu-state)]
    (if (empty? args)
      ;; Note that when run via Leiningen, 'read-line' does not work.
      ;; This is a known bug/feature in Ant, which apparently will not
      ;; be fixed in Ant. The workaround is to build this tooling as a
      ;; JAR file and then run it directly with 'java', using 'lein
      ;; classpath' output as the CLASSPATH.
      ;; E.g.
      ;; lein compile
      ;; java -cp ./clj-bin:`lein classpath` org.magnolialang.testutil.rascal_shell
      (RascalShell/runRepl compiler)
      (let [[mod args] [(first args) (or (rest args) ())]
            mod (if-let [r (re-find #"^(.*)[.]rsc$" mod)]
                  (.replaceAll (second r) "/" "::")
                  mod)]
        ;;(prn mod args)
        (System/exit (RascalShell/runModule compiler mod args))
        ))))
