#ifndef _MAGNOLIA_PRELUDE_ASSERT_HXX
#define _MAGNOLIA_PRELUDE_ASSERT_HXX

namespace Magnolia {
  namespace Assert {
    void axiom_assert(bool cond, const char* msg, const char* src, const char* loc) {
        if(!cond) {
                if(*loc != '\0')
                        std::cerr << loc << ": ";
                std::cerr << "Assertion failed";
                if(*src != '\0')
                        std::cerr << ": " << src;
                std::cerr << std::endl;
                if(*msg != '\0')
                        std::cerr << "    " << msg << std::endl;
        }
    }

    template<typename T, typename U>
    bool equal(T a, U b) { /*  std::cerr << a << " == " << b << " = " << (a == b) << std::endl; */ return a == b; }

    template<typename T, typename U>
    bool notEqual(T a, U b) { /* std::cerr << a << " != " << b << " = " << (a != b) << std::endl; */ return !(a == b); }

    void guardFailed(const char* msg, const char* src, const char* loc) {
		if(*loc != '\0')
				std::cerr << loc << ": ";
		std::cerr << "Guard failed";
		if(*src != '\0')
				std::cerr << ": " << src;
		std::cerr << std::endl;
		if(*msg != '\0')
				std::cerr << "    " << msg << std::endl;
    };

    template<typename T, typename U>
    const U& exprGuardFailed(const T& val, const char* msg, const char* src, const char* loc) {
		if(*loc != '\0')
				std::cerr << loc << ": ";
		std::cerr << "Guard failed";
		if(*src != '\0')
				std::cerr << ": " << src;
		std::cerr << std::endl;
		std::cerr << "Value " << val << std::endl;
		if(*msg != '\0')
				std::cerr << "    " << msg << std::endl;
    };
  }

  bool implies(bool a, bool b) {
  	return !a || b;
  }
}

#endif

