// implementation: implementation examples.Box.Box.Box, file: "examples/Box/CxxBox.hxx" 
#ifndef _INCLUDE_EXAMPLES_BOX_CXXBOX_HXX
#define _INCLUDE_EXAMPLES_BOX_CXXBOX_HXX
namespace Box {
	template<typename T>
	struct CxxBox {
		struct CxxBox_impl {
			struct Box {
				T data;
			public:
				Box(const T& t) : data(t) {}
				Box() = default;
				Box(const Box&) = default;
				~Box() = default;
				Box& operator=(const Box&) = default;
				bool operator==(const Box& _other) {
					
					return data == _other.data;
				}
				template<typename _Stream> void operator>>=(_Stream& _stream) const {
					Magnolia::IO::Type _type_tag = Magnolia::IO::Type("Box", "");
					
					Magnolia::IO::startData(_type_tag) >>= _stream;
					data >>= _stream;
					Magnolia::IO::endData(_type_tag) >>= _stream;
				}
				template<typename _Stream> void operator<<=(_Stream& _stream) {
					Magnolia::IO::Type _type_tag = Magnolia::IO::Type("Box", "");
					
					Magnolia::IO::startData(_type_tag) <<= _stream;
					data <<= _stream;
					Magnolia::IO::endData(_type_tag) <<= _stream;
				}
			};
			
			
			
			/** procedure box(obs :T, out :Box) */
			void box(const T& a, Box& b) const {
				b = Box(a);
			}
			
			/** procedure unbox(obs :Box, out :T) */
			void unbox(const Box& a, T& b) const {
				b = a.data;
			}
		};
		
		
	};
	
	
}

#endif
