// program: program mutification.Integer.FunProcInteger, file: "mutification/FunProcInteger.hxx" 
#ifndef _INCLUDE_MUTIFICATION_FUNPROCINTEGER_HXX
#define _INCLUDE_MUTIFICATION_FUNPROCINTEGER_HXX
namespace mutification {
namespace FunProcInteger {
	struct FunProcInteger_impl {
		typedef int Integer;
		
		
		/** procedure add(upd :Integer, obs :Integer) */
		void add(Integer& a, const Integer& addend) const {
			a += addend;
		}
		
		/** procedure div(upd :Integer, obs :Integer) */
		void div(Integer& a, const Integer& divisor) const {
			a /= divisor;
		}
		
		/** procedure mul(upd :Integer, obs :Integer) */
		void mul(Integer& a, const Integer& factor) const {
			a *= factor;
		}
		
		/** procedure neg(upd :Integer) */
		void neg(Integer& a) const {
			a = -a;
		}
		
		/** function one() : Integer */
		Integer one() const {
			return 1;
		}
		
		/** procedure one(out :Integer) */
		void onep(Integer& a) const {
			a = 1;
		}
		
		/** function _*_(:Integer, :Integer) : Integer */
		Integer times(const Integer& a, const Integer& factor) const {
			return a * factor;
		}
		
		/** function _+_(:Integer, :Integer) : Integer */
		Integer plus(const Integer& a, const Integer& addend) const {
			return a + addend;
		}
		
		/** function -_(:Integer) : Integer */
		Integer negate(const Integer& a) const {
			return -a;
		}
		
		/** function _-_(:Integer, :Integer) : Integer */
		Integer minus(const Integer& a, const Integer& subtrahend) const {
			return a - subtrahend;
		}
		
		/** function _/_(:Integer, :Integer) : Integer */
		Integer divide(const Integer& a, const Integer& divisor) const {
			return a / divisor;
		}
		
		/** procedure sub(upd :Integer, obs :Integer) */
		void sub(Integer& a, const Integer& subtrahend) const {
			a -= subtrahend;
		}
		
		/** function ten() : Integer */
		Integer ten() const {
			return 10;
		}
		
		/** procedure ten(out :Integer) */
		void tenp(Integer& a) const {
			a = 10;
		}
		
		/** function zero() : Integer */
		Integer zero() const {
			return 0;
		}
		
		/** procedure zero(out :Integer) */
		void zerop(Integer& a) const {
			a = 0;
		}
	};
	
	
}

}


#endif
